{{
**********************************
* jvmEngine - executes bytecodes *
**********************************
}}


CON
  'first 64
  Jem_NOP               = $00
  Jem_ICONST_M1         = $01
  Jem_ICONST_0          = $02
  Jem_ICONST_1          = $03
  Jem_ICONST_2          = $04
  Jem_ICONST_3          = $05
  Jem_ICONST_4          = $06
  Jem_ICONST_5          = $07
  Jem_BIPUSH            = $08
  Jem_SIPUSH            = $09
  Jem_ILOAD             = $0A
  Jem_ILOAD_0           = $0B
  Jem_ILOAD_1           = $0C
  Jem_ILOAD_2           = $0D
  Jem_ILOAD_3           = $0E
  Jem_ISTORE            = $0F
  Jem_ISTORE_0          = $10
  Jem_ISTORE_1          = $11
  Jem_ISTORE_2          = $12
  Jem_ISTORE_3          = $13
  Jem_IFEQ              = $14
  Jem_IFNE              = $15
  Jem_IFLT              = $16
  Jem_IFLE              = $17
  Jem_IFGT              = $18
  Jem_IFGE              = $19
  Jem_IF_ICMPEQ         = $1A
  Jem_IF_ICMPNE         = $1B
  Jem_IF_ICMPLT         = $1C
  Jem_IF_ICMPGE         = $1D
  Jem_IF_ICMPGT         = $1E
  Jem_IF_ICMPLE         = $1F
  Jem_IF_ACMPEQ         = $20
  Jem_IF_ACMPNE         = $21
  Jem_IRETURN           = $22
  Jem_RETURN            = $23
  Jem_INVOKEVIRTUAL     = $24
  Jem_INVOKESTATIC      = $25
  Jem_GETSTATIC         = $26
  Jem_PUTSTATIC         = $27
  Jem_POP               = $28
  Jem_POP2              = $29
  Jem_DUP               = $2A
  Jem_DUP_X1            = $2B
  Jem_DUP_X2            = $2C
  Jem_DUP2              = $2D
  Jem_DUP2_X1           = $2E
  Jem_DUP2_X2           = $2F
  Jem_SWAP              = $30
  Jem_IADD              = $31
  Jem_ISUB              = $32
  Jem_INEG              = $33
  Jem_IOR               = $35
  Jem_ISHL              = $37
  Jem_ISHR              = $39
  Jem_IUSHR             = $3B
  Jem_IAND              = $3D
  Jem_IXOR              = $3F
  Jem_I2B               = $41
  Jem_GOTO              = $43
  Jem_INVOKEINTERFACE   = $45
  Jem_ARRAYLENGTH       = $47
  Jem_ATHROW            = $49
  Jem_CHECKCAST         = $4B
  'next 64
  Jem_INSTANCEOF        = $4D
  Jem_WIDE              = $4F
  Jem_IINC              = $51
  Jem_GETFIELD          = $53
  Jem_PUTFIELD          = $55
  Jem_NEW               = $57
  Jem_NEWARRAY          = $59
  Jem_ANEWARRAY         = $5B
  Jem_IALOAD            = $5D
  Jem_IASTORE           = $5F
  Jem_BALOAD            = $61
  Jem_BASTORE           = $63
  Jem_LDC               = $65
  Jem_LDC_W             = $67
  Jem_LDC2_W            = $69
  Jem_IMUL              = $6B
  Jem_IDIV              = $6D
  Jem_IREM              = $6F
  Jem_JSR               = $71
  Jem_RET               = $73
  Jem_TABLESWITCH       = $75
  Jem_LOOKUPSWITCH      = $77


OBJ
  comm:          "jvmCommAsm" 'communication port object
  jd:            "jvmDataAsm" 'jvm memory access object

  jStack:        "jvmStackAsm"

  jbh1:          "jvmBytecodeHandler1"  
  jbh2:          "jvmBytecodeHandler2"

{  
  jConst:        "jvmConst"
  jLoad:         "jvmLoad"
  jStore:        "jvmStore"
  jCompareJump:  "jvmCompareJump"
  jInvoke:       "jvmInvoke"
  jMath:         "jvmMath"
  jArray:        "jvmArray"
  jObject:       "jvmObject"
  jSubReturn:    "jvmSubReturn"
  jLogic:        "jvmLogic"
  jConvert:      "jvmConvert"
  jException:    "jvmException"
}

VAR

  'ATTENTION: DON'T CHANGE THE ORDER OF THE FOLLOWING VARIABLES.
  byte  JemCode                 'communication with assembly cog
                                'put a jemcode <> 0 and byte code
                                'is handled by assembly code
                                'it's zero if byte code is processed
  byte  NativeFunc              'communication between assembly cogs for native functions
                                'it's zero if native function is processed

                              
PUB start : ptrVars

  ptrVars := jd.getPtrJvmVars
  jbh1.start(ptrVars, @JemCode)
  jbh2.start(ptrVars, @JemCode)


PUB doBytecode: value | state,c
{{ Execute a bytecode }}
  if jd.getJvmPC < $0014 AND jd.getActivity <> jd#kEnd  '$0014 is address of first class header
    jd.setActivity(jd#kEnd)
    comm.end
  state := jd.getActivity
  case state
    jd#kRun    : 'JVM running
                 if jd.isBreakpoint
                   comm.breakpoint
                   return -1
                 else
                   c := doStep
                   if jd.mustNotifyStepDone
                     comm.notifyStepDone
                   return c
    jd#kBreak  : 'appears not to be used
                 'so change state to kPassive
                 return -1
    jd#kPassive: 'JVM was running but has stopped (exception,stopped,end)
                 if jd.mustStep
                   c := doStep
                   if jd.mustNotifyStepDone
                     comm.notifyStepDone
                    return c
                 return -1
    jd#kJog    : 'appears not to be used
                 'so change state to kPassive
                 jd.setActivity(jd#kPassive)
                 return -1
    jd#kEnd:     'do nothing
                 return -1
  return -1


PUB doStepPropIt(bytecode): value
{{ used for automated testing, perform a step }}
  JemCode := bytecode
  if JemCode == Jem_NOP
    jStack.jb_nop

  repeat until JemCode == 0

  
PRI doStep: value
{{ perform a step }}
  JemCode := jd.readJavaByte(jd.getJvmPC)
  if JemCode == Jem_NOP
    jStack.jb_nop

  repeat until JemCode == 0
  
  return -1

'  